首页 > 代码库 > HDU 2639 Bone Collector II
HDU 2639 Bone Collector II
Bone Collector II
Time Limit: 5000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2089 Accepted Submission(s): 1097
Problem Description
The title of this problem is familiar,isn‘t it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven‘t seen it before,it doesn‘t matter,I will give you a link:
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).
Sample Input
3 5 10 2 1 2 3 4 5 5 4 3 2 1 5 10 12 1 2 3 4 5 5 4 3 2 1 5 10 16 1 2 3 4 5 5 4 3 2 1
Sample Output
12 2 0
Author
teddy
Source
百万秦关终属楚
Recommend
teddy | We have carefully selected several similar problems for you: 2602 2159 1203 2955 1114
解题思路:求背包的第k大方案,只需在状态上加入一维dp[j][k]表示前i个物品装入容量为j的背包的第k大的方案,用两个数组辅助保存下装和不装两种选择下的前k大方案,再最后合并起来得到最终结果
#include <iostream> using namespace std; bool cmp(int a,int b) {return a>b;} int main(){ int i,j,t,n,v,k,p; int cost[105],val[105],dp[1005][35],a[35],b[35]; //freopen("in.txt","r",stdin); //freopen("out.txt","w",stdout); scanf("%d",&t); while(t--){ memset(dp,0,sizeof(dp)); scanf("%d%d%d",&n,&v,&k); for(i=0;i<n;i++) scanf("%d",val+i); for(i=0;i<n;i++) scanf("%d",cost+i); for(i=0;i<n;i++) for(j=v;j>=cost[i];j--){ for(p=0;p<k;p++){ a[p]=dp[j][p]; b[p]=dp[j-cost[i]][p]+val[i]; } int s=0,t=0; p=0; a[k]=b[k]=-1; while(p<k&&!(a[s]==-1&&b[t]==-1)){ if(a[s]>b[t]) dp[j][p]=a[s++]; else dp[j][p]=b[t++]; if(dp[j][p]!=dp[j][p-1]) p++; } } printf("%d\n",dp[v][k-1]); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。